
#include <Python.h>

#include <stdio.h>
#include <cstdlib>
#include <mpi.h>

#include "src1.h"

/** The main program
 *
 *
 */
int main(int argc, char** argv)
{    
    double      start = 0.,
                end   = 0.;
    
    MPI_Init(&argc,&argv);

    MPI_Comm    comm = MPI_COMM_NULL;    
    MPI_Comm_dup(MPI_COMM_WORLD,&comm);
    
    int             myrank   = 0,
                    numprocs = 0;
    MPI_Comm_rank(comm,&myrank  );
    MPI_Comm_size(comm,&numprocs);    

    S     inst(comm);    
    
    /* Start time measurement */
    start = MPI_Wtime();

    /* IMPORTANT: Recompute your rank */
    MPI_Comm_rank(inst.comm,&myrank);
        
    end = MPI_Wtime();
    if(0 == myrank) {
        printf("Wall clock time = %16.15f\n",end - start);
    }
    
    MPI_Finalize();
    
    return EXIT_SUCCESS;
}
